﻿using System.Runtime.InteropServices;
using CGroupBasedTargetMemoryControl.Util;

namespace CGroupBasedTargetMemoryControl.Service
{
    public class CGroupService
    {
        private readonly int ECGEOF = 50023;

        public int Test()
        {
            unsafe
            {
                int size;
                int ret;

                IntPtr pidsPtr;
                int i;

                ret = LibCGroup.cgroup_init();
                if (ret != 0)
                {
                    Console.WriteLine(
                        "FAIL: cgroup_init failed with %s\n" + LibCGroup.GetErrorString(ret)
                    );
                    return 3;
                }

                ret = LibCGroup.cgroup_get_procs("a", "memory", out pidsPtr, out size);
                if (ret != 0)
                {
                    Console.WriteLine(
                        "FAIL: cgroup_get_procs failed with %s\n" + LibCGroup.GetErrorString(ret)
                    );
                    return 3;
                }
                int[] pids = new int[size];
                Marshal.Copy(pidsPtr, pids, 0, size);
                for (i = 0; i < size; i++)
                    Console.WriteLine(pids[i]);

                // 释放pidsPtr内存（如果libcgroup要求你负责释放，需查阅文档）
            }
            return 0;
        }
    }
}
